import { Request, NextFunction, Router } from 'express';
import { AfterHandlerMiddleware } from './middlewares/after.handler.middleware';
import { BeforeHandlerMiddleware } from './middlewares/before.handler.middleware';
import { Response } from './response';
export type MiddlewareHandler = (req: Request, res: Response, next: NextFunction) => void;
export type MiddlewareErrorHandler = (err: Error, req: Request, res: Response, next: NextFunction) => void;
export type Middlewares = (MiddlewareHandler | MiddlewareErrorHandler | AfterHandlerMiddleware | BeforeHandlerMiddleware)[];
export interface OrderedMiddlewares {
    before: Middlewares;
    after: Middlewares;
}
export type GenericObject = {
    [key: string]: any;
};
export type ResponseValidator = (res: Response) => void;
export interface RouterWithHandler extends Router {
    handle(req: Request, res: Response, next: NextFunction): void;
}
